'========================================================*
'     433              *
'          *
'                          *
'                                                        *
'                                                        *
'                                                        *
'========================================================*
Device 16F628A  ;  16LF628     (2-5,5)

'----------------------------------------------- 
Config INTOSC_OSC_CLKOUT, CP_OFF, mclre_off, lvp_off, boden_off, PWRTE_OFF, WDT_On
;      

Xtal 4                          ; 4.000 


'---------------------------------------------------------------------
'--------------------  -------------------------------
'---------------------------------------------------------------------
PCON        = %00001011
OPTION_REG  = %10000011         ' TMR0 1/16
INTCON      = %11100000         ;   TMR0 (4 ms)
PIE1        = %00000000         '   
PIR1        = %00000000         '   
CMCON       = %00000111         '  
T1CON       = %00000000         ' TMR1 1/1
T2CON       = %00000010         ' TMR2 1/16

'---------------------------------------------------------------------
'-----------------------------------------------------------
'---------------------------------------------------------------------
' 

Dim Cifra6		As Byte			;   
Dim Cifra5		As Byte			; 
Dim Cifra4		As Byte			; 
Dim Cifra3   	As Byte			    ; 
Dim Cifra2		As Byte			; 
Dim Cifra1		As Byte			; 
Dim tmp         As Byte         ;    ()
Dim ADDRESS		As Byte			;      
Dim SELECTOR	As Byte			;   
Dim OUTA		As Byte			; 
Dim Cifra       As Byte
Dim DigitDisp   As Byte          ;  


Dim Reg_1       As Byte
Dim Reg_2       As Byte
Dim Reg_3       As Byte
Dim w           As Word
Dim cobak       As Byte
Dim knn         As Byte
Dim ds          As Bit ' 
Dim tem         As Word
Dim pr          As Bit
Dim vr          As Word
Dim sig         As Word
Dim TemperC     As  Word
Dim sign        As  Byte
Dim rprd        As Dword
Dim prm        As Dword
Dim  serial    As Word
Dim temperatur1 As Word
Dim sign1       As Byte

'--------------------------------------------------------------------






Dim Nomer_bita      As Byte        '   
Dim Prinimaem       As Byte        '   
Dim Nomer_byta      As Byte        '   
Dim CRC             As Word        ;    
Dim Vihod_priemnika As PORTA.5     ;  
Dim dan[38] As Byte
Dim i As Byte








'---------------------------------------------------------------------
'--------------------------------------------------------
'---------------------------------------------------------------------
Clear
TRISA = %11110000
TRISB = %00000000
PORTA = 0
PORTB = 0


'cobak=0 '   
cobak=1 '   


     If cobak=0 Then  '      
     Cifra1=%01000000 
     Cifra2=%01000000 
     Cifra3=%01000000 
     Cifra4=%01000000 
     Else
     Cifra1=%10111111 
     Cifra2=%10111111 
     Cifra3=%10111111 
     Cifra4=%10111111 
     EndIf
     




serial=2487'   
'        

SELECTOR =4
tmp = SELECTOR
While tmp = SELECTOR      
Wend             

GoTo scan_vhoda_priemnika

On_Interrupt GoTo prer




'=================================================================
'        ()
'=================================================================    
valtemp:





     If cobak=0 Then  ' 
     Cifra1=%00000000 
     Cifra2=%00000000 
     Cifra3=%00000000 
     Cifra4=%00000000 
     Else
     Cifra1=%11111111 
     Cifra2=%11111111 
     Cifra3=%11111111 
     Cifra4=%11111111 
     EndIf
     
 If ds=0 Then '    OFF   
If cobak=0 Then
Cifra3=%01110001 'F
Cifra2=%01110001 'F
Cifra1=%00111111 'O
Else
Cifra3=%10001110 'F
Cifra2=%10001110 'F
Cifra1=%11000000 'O
EndIf
Return
EndIf    
    

knn=0
DigitDisp = TemperC Dig 3  '1-
GoSub LOOK

If  DigitDisp<>0 Then
     Cifra1 =Cifra
     DigitDisp = TemperC Dig 2  '2-
     GoSub LOOK
     Cifra2 =Cifra
     knn=1
EndIf     
     
     
     
     
If  knn=0 Then 
 DigitDisp = TemperC Dig 2  '2-
 GoSub LOOK

  If  DigitDisp<>0 Then 
    Cifra2 =Cifra
       
    If sign = 200 Then 
      If cobak=0 Then
      Cifra1=%01000000 
      Else
      Cifra1=%10111111
      EndIf
    EndIf 
  Else
   If sign =200 Then 
    If cobak=0 Then
    Cifra2=%01000000 
    Else
    Cifra2=%10111111
    EndIf
   EndIf 
EndIf
EndIf  
    
      DigitDisp = TemperC Dig 1  '2-
      GoSub LOOK
      Cifra3 =Cifra 
      
    If cobak=0 Then
    Cifra4=%01100011
    Else
    Cifra4=%10011100
    EndIf 
    
 
       
Return
 
 
 
    
LOOK:;       
If cobak=0 Then
;       
Cifra = LookUpL DigitDisp,[63,6,91,79,102,109,125,7,127,111] 
Else 
'      
Cifra = LookUpL DigitDisp,[192,249,164,176,153,146,130,248,128,144] 
EndIf         
Return
      
      










'---------------------------------------------------------------------
'-------------------  TMR0 4ms----------------------------
'--------------------------------------------------------------------
prer:
Context Save 





INTCON.2 = 0
TMR0 = TMR0 + 75

 
          
             If cobak=0 Then         
            OUTA = %11101111
            Else
            OUTA = %00010000
            EndIf
            
            PORTA = OUTA
            OUTA = SELECTOR - 1
            
        FSR =ADDRESS      ;   FSR   
        PORTB = INDF       ;        FIG....
        
             
        If cobak<>0 Then
        
         If SELECTOR=1 Then 
         PORTA.0=1
         PORTA.1=0
         PORTA.2=0
         PORTA.3=0
         EndIf
         
         
         If SELECTOR=2 Then 
         PORTA.0=0
         PORTA.1=1
         PORTA.2=0
         PORTA.3=0
         EndIf
         
         If SELECTOR=3 Then 
         PORTA.0=0
         PORTA.1=0
         PORTA.2=1
         PORTA.3=0
         EndIf
         
         If SELECTOR=4 Then 
         PORTA.0=0
         PORTA.1=0
         PORTA.2=0
         PORTA.3=1
         EndIf
         
         Else
         
         If SELECTOR=1 Then 
         PORTA.0=0
         PORTA.1=1
         PORTA.2=1
         PORTA.3=1
         EndIf
         
         
         If SELECTOR=2 Then 
         PORTA.0=1
         PORTA.1=0
         PORTA.2=1
         PORTA.3=1
         EndIf
         
         If SELECTOR=3 Then 
         PORTA.0=1
         PORTA.1=1
         PORTA.2=0
         PORTA.3=1
         EndIf
         
         If SELECTOR=4 Then 
         PORTA.0=1
         PORTA.1=1
         PORTA.2=1
         PORTA.3=0
         EndIf
         
         EndIf

        Dec SELECTOR
                
        If SELECTOR = 0 Then
            Asm 
        		Movlw	Cifra4			;    1-    
        		Movwf	ADDRESS			;   ADDRESS
            EndAsm
		SELECTOR =4	; 1-
        GoTo End_int
        EndIf
Int_label:
	Inc      ADDRESS             ;  
	Asm
    	Nop
		Nop
		GoTo      End_int               
    EndAsm
End_int:


Clrwdt                         ;   
Context Restore                ;  














'-----------------------------------------------------------------------------------
'-------------------- (   _/\_ 10)------------------------
'-----------------------------------------------------------------------------------

scan_vhoda_priemnika:


'       
If PORTA.4=0 Then  
temperatur1=TemperC 
sign1=sign
       
TemperC=0
sign=0
GoSub valtemp 
DelayMS 5000

TemperC=temperatur1
sign=sign1
GoSub valtemp 
 
EndIf





Inc rprd

If rprd>2000000 Then '      10     OFF
ds=0
tmp = SELECTOR
While tmp = SELECTOR  
Wend  
GoSub valtemp 
EndIf



Inc prm

If prm>=5000 Then
If cobak=0 Then
If pr=0 Then Cifra4=%01100011
If pr=1 Then Cifra4=%11100011
Else
If pr=0 Then Cifra4=%10011100
If pr=1 Then Cifra4=%00011100
EndIf 
pr=0
prm=0    
EndIf



    If Vihod_priemnika = 1 Then                         ;     
    T1CON.0 = 1                                         ;  1
    If TMR1H > 54 Then T1CON.0 = 0                      ;   14 (54*256) -  1
    DelayUS 36                                          ;    0  1 DelayUS 38
    Else                                                ;  , 
    T1CON.0 = 0                                         ;  1
    If TMR1H > 31 And TMR1H < 47 Then                   ;      8..12 (31..47),    
    rprd=0                                              '    
    ds=1                                                '   
    GoSub svoy_signal
    EndIf
    TMR1H = 0: TMR1L = 0                                ;  1
    EndIf 
GoTo scan_vhoda_priemnika


'-----------------------------  ------------------------------------
svoy_signal:
TMR1H = 0                                           ;  1
TMR1L = 0                                           ;  1
CRC = 0                                             ;   - 

;----------------------------------- ------------------------
DelayUS 500                                      ;      
For Nomer_byta = 0 To 23                          ; 24 
    Prinimaem = 0 
                                   ;   
    For Nomer_bita = 0 To 7                      ; 8 
'----------------------------   0/1 ---------------
        DelayUS 400                              ;      
        TMR2 = 0                                 ;  _2
        T2CON.2 = 1                              ;  _2
        While Vihod_priemnika = 0                ;    0
        If TMR2 >= 125 Then GoTo scan_vhoda_priemnika    ;   2  (125*16: 16-  _2)
        Wend                                     ;   _2     ()
        
        TMR2 = 0                                 ;  _2
        While Vihod_priemnika = 1                ;    1
        If TMR2 >= 93 Then GoTo scan_vhoda_priemnika      ;   1.5  (93*16: 16-  _2)
        Wend                                     ;   _2     ()
        T2CON.2 = 0                                                                                                                                       

'-------------------------   -----------------------
        Prinimaem = Prinimaem>>1                 ;      ()
        Select TMR2                              ;  
        Case  20 To 51 : Prinimaem.7 = 0         ;  600  (+/-15%+/-100 410..790  25..50),  
        Case  56 To 95 : Prinimaem.7 = 1         '  1200 (+/-15%+/-100 920..1480 57..92) - 
        '   (+/-100) - ,       100 
        Case Else      : GoTo scan_vhoda_priemnika        ;   -    
        End Select
        Next 
        
        
'       
dan[Nomer_byta] = Prinimaem      
Next

'  
For i=0 To 21
CRC=CRC+dan[i]
Next
dan[23]=CRC.HighByte
dan[24]=CRC.LowByte
'-----------------------------------


If CRC.HighByte=dan[23] And CRC.LowByte=dan[24] And dan[0]=serial.HighByte And dan[1]=serial.LowByte Then 
T2CON.2 = 0 
TMR2 = 0 
TemperC=dan[2]
sign=dan[3] 
pr=1
'prm=0 
rprd=0  
TemperC=TemperC*10      
EndIf



tmp = SELECTOR
While tmp = SELECTOR  
Wend  
GoSub valtemp 





Return
      
      


End
